#!/bin/bash

# Copyright (C) 2016, 2017, 2018, 2019, 2020, 2021  Stefan Vargyas
# 
# This file is part of Json-Type.
# 
# Json-Type is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Json-Type is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Json-Type.  If not, see <http://www.gnu.org/licenses/>.

#
# File generated by a command like:
# $ json-gentest -C filter:dyn-lib3
#

[[ "$1" =~ ^-u[0-9]+$ ]] &&
u="${1:2}" ||
u=""

diff -u$u -L dyn-lib3.old <(echo \
'$ json0() { LD_LIBRARY_PATH=../lib ../src/json "$@"; }
$ json() { json0 -F "$@"; }
$ json libs/test-type/test-type.so
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json libs/test-type/test-type.so
$ json -- libs/test-type/test-type.so
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so
$ json -- libs/test-type/test-type.so a b c
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so a b c
$ json -- libs/test-type/test-type.so -- ./foo.so
json: warning: action `-F|--filterlib-exec'\'': multiple filter command line arguments groups given
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so -- ./foo.so
$ json -- libs/test-type/test-type.so a b c -- ./foo.so d e
json: warning: action `-F|--filterlib-exec'\'': multiple filter command line arguments groups given
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so a b c -- ./foo.so d e
$ json -V libs/test-type/test-type.so
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V libs/test-type/test-type.so
$ json -V -- libs/test-type/test-type.so
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so
$ json -V -- libs/test-type/test-type.so a b c
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so a b c
$ json -V -- libs/test-type/test-type.so -- ./foo.so
json: warning: action `-F|--filterlib-exec'\'': multiple filter command line arguments groups given
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so -- ./foo.so
$ json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e
json: warning: action `-F|--filterlib-exec'\'': multiple filter command line arguments groups given
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e
$ json() { json0 -f "$@" <<< '\'''\''; }
$ json -- libs/test-type/test-type.so
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so
$ json -- libs/test-type/test-type.so a b c
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so a b c
$ json -- libs/test-type/test-type.so -- ./foo.so
json: error: libs/test-type/test-type.so: filter library #1: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so -- ./foo.so
$ json -- libs/test-type/test-type.so a b c -- ./foo.so d e
json: error: libs/test-type/test-type.so: filter library #1: '\''filter_get_version'\'' symbol not found
command failed: json -- libs/test-type/test-type.so a b c -- ./foo.so d e
$ json -V libs/test-type/test-type.so
json: error: option `-f|--filter-libs'\'' requires at least one filter command line arguments group
command failed: json -V libs/test-type/test-type.so
$ json -V -- libs/test-type/test-type.so
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so
$ json -V -- libs/test-type/test-type.so a b c
json: error: libs/test-type/test-type.so: filter library: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so a b c
$ json -V -- libs/test-type/test-type.so -- ./foo.so
json: error: libs/test-type/test-type.so: filter library #1: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so -- ./foo.so
$ json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e
json: error: libs/test-type/test-type.so: filter library #1: '\''filter_get_version'\'' symbol not found: dlsym failed: libs/test-type/test-type.so: undefined symbol: test_type_filter_get_version
command failed: json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e'
) -L dyn-lib3.new <(
echo '$ json0() { LD_LIBRARY_PATH=../lib ../src/json "$@"; }'
json0() { LD_LIBRARY_PATH=../lib ../src/json "$@"; } 2>&1 ||
echo 'command failed: json0() { LD_LIBRARY_PATH=../lib ../src/json "$@"; }'

echo '$ json() { json0 -F "$@"; }'
json() { json0 -F "$@"; } 2>&1 ||
echo 'command failed: json() { json0 -F "$@"; }'

echo '$ json libs/test-type/test-type.so'
json libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json libs/test-type/test-type.so'

echo '$ json -- libs/test-type/test-type.so'
json -- libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so'

echo '$ json -- libs/test-type/test-type.so a b c'
json -- libs/test-type/test-type.so a b c 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so a b c'

echo '$ json -- libs/test-type/test-type.so -- ./foo.so'
json -- libs/test-type/test-type.so -- ./foo.so 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so -- ./foo.so'

echo '$ json -- libs/test-type/test-type.so a b c -- ./foo.so d e'
json -- libs/test-type/test-type.so a b c -- ./foo.so d e 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so a b c -- ./foo.so d e'

echo '$ json -V libs/test-type/test-type.so'
json -V libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json -V libs/test-type/test-type.so'

echo '$ json -V -- libs/test-type/test-type.so'
json -V -- libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so'

echo '$ json -V -- libs/test-type/test-type.so a b c'
json -V -- libs/test-type/test-type.so a b c 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so a b c'

echo '$ json -V -- libs/test-type/test-type.so -- ./foo.so'
json -V -- libs/test-type/test-type.so -- ./foo.so 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so -- ./foo.so'

echo '$ json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e'
json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e'

echo '$ json() { json0 -f "$@" <<< '\'''\''; }'
json() { json0 -f "$@" <<< ''; } 2>&1 ||
echo 'command failed: json() { json0 -f "$@" <<< '\'''\''; }'

echo '$ json -- libs/test-type/test-type.so'
json -- libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so'

echo '$ json -- libs/test-type/test-type.so a b c'
json -- libs/test-type/test-type.so a b c 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so a b c'

echo '$ json -- libs/test-type/test-type.so -- ./foo.so'
json -- libs/test-type/test-type.so -- ./foo.so 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so -- ./foo.so'

echo '$ json -- libs/test-type/test-type.so a b c -- ./foo.so d e'
json -- libs/test-type/test-type.so a b c -- ./foo.so d e 2>&1 ||
echo 'command failed: json -- libs/test-type/test-type.so a b c -- ./foo.so d e'

echo '$ json -V libs/test-type/test-type.so'
json -V libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json -V libs/test-type/test-type.so'

echo '$ json -V -- libs/test-type/test-type.so'
json -V -- libs/test-type/test-type.so 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so'

echo '$ json -V -- libs/test-type/test-type.so a b c'
json -V -- libs/test-type/test-type.so a b c 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so a b c'

echo '$ json -V -- libs/test-type/test-type.so -- ./foo.so'
json -V -- libs/test-type/test-type.so -- ./foo.so 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so -- ./foo.so'

echo '$ json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e'
json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e 2>&1 ||
echo 'command failed: json -V -- libs/test-type/test-type.so a b c -- ./foo.so d e'
)

